com.tibbo.aggregate.common.datatable

## Class DataTableBindingProvider

- java.lang.Object
- - com.tibbo.aggregate.common.binding.AbstractBindingProvider
  - - com.tibbo.aggregate.common.datatable.AbstractDataTableBindingProvider
    - - com.tibbo.aggregate.common.datatable.DataTableBindingProvider

- All Implemented Interfaces:
    BindingProvider

      public class DataTableBindingProvider
      extends AbstractDataTableBindingProvider

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `PROPERTY_CHOICES`
    `static java.lang.String` | `PROPERTY_ENABLED`
    `static java.lang.String` | `PROPERTY_HIDDEN`
    `static java.lang.String` | `PROPERTY_OPTIONS`

    - ### Fields inherited from class com.tibbo.aggregate.common.datatable.AbstractDataTableBindingProvider

      `listeners, listenersLock, NEW_RECORD_REFERENCE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DataTableBindingProvider(DataTable table)`
    `DataTableBindingProvider(DataTable table, ErrorCollector errorCollector)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `callReferenceChanged(Reference cause, int method, ReferenceListener listener, boolean asynchronousProcessing)`
    `java.util.Map<Binding,EvaluationOptions>` | `createBindings()` Returns bindings provided by the Provider.
    `protected ReferenceWriter` | `getExternalReferenceWriter()`
    `protected FieldFormat` | `getFieldFormat(int row, java.lang.String field)`
    `protected void` | `setCellValue(java.lang.Object value, int row, java.lang.String field)`
    `protected void` | `setEditorEnabled(boolean enabled)`
    `protected void` | `setEnabled(java.lang.Object value, int row, java.lang.String field)`
    `protected void` | `setHidden(java.lang.Object value, int row, java.lang.String field)`
    `protected void` | `setOptions(java.lang.Object value, int row, java.lang.String field)`
    `protected void` | `setSelectionValues(java.lang.Object value, int row, java.lang.String field)`
    `void` | `start()` Method called by `BindingProcessor` upon its startup.
    `void` | `stop()` Method called by `BindingProcessor` upon its termination.
    `void` | `writeReference(int method, Binding binding, Reference cause, java.lang.Object value, ChangeCache cache, Pinpoint pinpoint)` Method is called once a binding was executed, its expression evaluated to some result and the provider needs to write the result into binding target.

    - ### Methods inherited from class com.tibbo.aggregate.common.datatable.AbstractDataTableBindingProvider

      `addReferenceListener, getListenerCount, getListeners, getListenersLock, getReferences, isLocalReference, processBindings, removeReferenceListener, writeReference`

    - ### Methods inherited from class com.tibbo.aggregate.common.binding.AbstractBindingProvider

      `buildErrorMessage, buildExecutionMessage, processError, processExecution`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### PROPERTY_ENABLED

          public static final java.lang.String PROPERTY_ENABLED

      See Also:
        Constant Field Values

    - #### PROPERTY_HIDDEN

          public static final java.lang.String PROPERTY_HIDDEN

      See Also:
        Constant Field Values

    - #### PROPERTY_CHOICES

          public static final java.lang.String PROPERTY_CHOICES

      See Also:
        Constant Field Values

    - #### PROPERTY_OPTIONS

          public static final java.lang.String PROPERTY_OPTIONS

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### DataTableBindingProvider

          public DataTableBindingProvider(DataTable table)

    - #### DataTableBindingProvider

          public DataTableBindingProvider(DataTable table,
                                          ErrorCollector errorCollector)

  - ### Method Detail

    - #### createBindings

          public java.util.Map<Binding,EvaluationOptions> createBindings()

      Description copied from interface: `BindingProvider`
      Returns bindings provided by the Provider.
      Returns:
        Map of bindings and their `EvaluationOptions`

    - #### callReferenceChanged

          protected void callReferenceChanged(Reference cause,
                                              int method,
                                              ReferenceListener listener,
                                              boolean asynchronousProcessing)

      Specified by:
        `callReferenceChanged` in class `AbstractDataTableBindingProvider`

    - #### getExternalReferenceWriter

          protected ReferenceWriter getExternalReferenceWriter()

      Specified by:
        `getExternalReferenceWriter` in class `AbstractDataTableBindingProvider`

    - #### setCellValue

          protected void setCellValue(java.lang.Object value,
                                      int row,
                                      java.lang.String field)

      Specified by:
        `setCellValue` in class `AbstractDataTableBindingProvider`

    - #### setEnabled

          protected void setEnabled(java.lang.Object value,
                                    int row,
                                    java.lang.String field)

      Specified by:
        `setEnabled` in class `AbstractDataTableBindingProvider`

    - #### setHidden

          protected void setHidden(java.lang.Object value,
                                   int row,
                                   java.lang.String field)

      Specified by:
        `setHidden` in class `AbstractDataTableBindingProvider`

    - #### setOptions

          protected void setOptions(java.lang.Object value,
                                    int row,
                                    java.lang.String field)

      Specified by:
        `setOptions` in class `AbstractDataTableBindingProvider`

    - #### setSelectionValues

          protected void setSelectionValues(java.lang.Object value,
                                            int row,
                                            java.lang.String field)

      Specified by:
        `setSelectionValues` in class `AbstractDataTableBindingProvider`

    - #### setEditorEnabled

          protected void setEditorEnabled(boolean enabled)

      Specified by:
        `setEditorEnabled` in class `AbstractDataTableBindingProvider`

    - #### start

          public void start()

      Description copied from interface: `BindingProvider`
      Method called by `BindingProcessor` upon its startup. Should implement initialization logic.

    - #### stop

          public void stop()

      Description copied from interface: `BindingProvider`
      Method called by `BindingProcessor` upon its termination. Should implement cleanup logic.

    - #### writeReference

          public void writeReference(int method,
                                     Binding binding,
                                     Reference cause,
                                     java.lang.Object value,
                                     ChangeCache cache,
                                     Pinpoint pinpoint)
                              throws BindingException

      Description copied from interface: `BindingProvider`
      Method is called once a binding was executed, its expression evaluated to some result and the provider needs to write the result into binding target.
      Parameters:
        `method` - Binding execution method: EvaluationOptions.STARTUP, EvaluationOptions.EVENT or EvaluationOptions.PERIODIC
        `binding` - The `Binding` itself
        `cause` - Execution cause
        `value` - Value to write to the target
        `cache` - Change cache
        `pinpoint` - Origin of the writing
      Throws:
        `BindingException` - if writing was not successful

    - #### getFieldFormat

          protected FieldFormat getFieldFormat(int row,
                                               java.lang.String field)
                                        throws BindingException

      Throws:
        `BindingException`